diff --git a/source/simulation2/components/CCmpPathfinder_JPS.cpp b/source/simulation2/components/CCmpPathfinder_JPS.cpp
new file mode 100644
index 0000000..cd9f543
--- /dev/null
+++ b/source/simulation2/components/CCmpPathfinder_JPS.cpp
@@ -0,0 +1,1069 @@
+/* Copyright (C) 2011 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "CCmpPathfinder_Common.h"
+
+#include "lib/bits.h"
+#include "lib/sysdep/rtl.h"
+#include "ps/Profile.h"
+#include "renderer/TerrainOverlay.h"
+#include "simulation2/helpers/PriorityQueue.h"
+
+#define PATHFIND_STATS 0
+
+#define USE_JUMPPOINT_CACHE 1
+
+namespace
+{
+
+struct Cost
+{
+	Cost() : data(0) { }
+	Cost(u16 hv, u16 d) : data(hv*65536 + d*92682) { }
+
+	static Cost horizvert(u16 n)
+	{
+		return Cost(n, 0);
+	}
+
+	static Cost diag(u16 n)
+	{
+		return Cost(0, n);
+	}
+
+	Cost operator+(const Cost& a) const
+	{
+		Cost c;
+		c.data = data + a.data;
+		return c;
+	}
+
+	bool operator<(const Cost& b) const
+	{
+		return data < b.data;
+	}
+
+	bool operator>=(const Cost& b) const
+	{
+		return data >= b.data;
+	}
+
+	bool operator>(const Cost& b) const
+	{
+		return data > b.data;
+	}
+
+	u32 ToInt()
+	{
+		return data;
+	}
+
+	u32 data;
+};
+
+
+struct CostAndExtra1
+{
+	CostAndExtra1() {}
+
+	Cost GetCost() const
+	{
+		return c;
+	}
+
+	void SetCost(Cost c_)
+	{
+		c = c_;
+	}
+
+	u8 GetStatus() const
+	{
+		return data & 3;
+	}
+
+	void SetStatus(u8 s)
+	{
+		ASSERT(s < 4);
+		data &= ~3;
+		data |= (s & 3);
+	}
+
+	int GetPredDI() const
+	{
+		return (i32)data >> 17;
+	}
+
+	int GetPredDJ() const
+	{
+		return ((i32)data << 15) >> 17;
+	}
+
+	void SetPred(int di, int dj)
+	{
+		ASSERT(-16384 <= di && di < 16384);
+		ASSERT(-16384 <= dj && dj < 16384);
+		data &= 3;
+		data |= (((u32)di & 0x7FFF) << 17) | (((u32)dj & 0x7FFF) << 2);
+	}
+
+private:
+	Cost c;
+	u32 data;
+};
+
+//cassert(sizeof(CostAndExtra1) == 8);
+typedef CostAndExtra1 CostAndExtra;
+
+bool operator>=(const Cost& a, const CostAndExtra& b)
+{
+	return a >= b.GetCost();
+}
+
+typedef PriorityQueueHeap<TileID, Cost> PriorityQueue;
+
+class JumpPointCache
+{
+	struct RowRaw
+	{
+		u16 last;
+
+		RowRaw(u16 length)
+		{
+			data.resize(length);
+			last = 0;
+		}
+
+		void SetRange(u16 x0, u16 x1, u16 val)
+		{
+			ENSURE(last == x0);
+			ENSURE(x0 <= x1);
+			ENSURE(x1 < data.size());
+			last = x1;
+			for (u16 x = x0; x < x1; ++x)
+				data[x] = val;
+		}
+
+		u16 Get(u16 x)
+		{
+			ENSURE(0 <= x && x < data.size());
+			return data[x];
+		}
+
+		void Finish() { }
+
+		std::vector<u16> data;
+	};
+
+	struct RowTree
+	{
+		u16 last;
+
+		struct Interval
+		{
+			u16 x0;
+			u16 x1;
+			u16 val;
+		};
+		struct Interval2
+		{
+			u16 x0;
+			u16 x1;
+		};
+		std::vector<Interval> data;
+		std::vector<Interval2> tree;
+
+		RowTree(u16 length)
+		{
+			last = 0;
+		}
+
+		void SetRange(u16 x0, u16 x1, u16 val)
+		{
+			ENSURE(last == x0);
+			ENSURE(x0 <= x1);
+			ENSURE(val == 0 || val == x1);
+			last = x1;
+
+			// If the last interval was 0 and this is too, extend the last interval;
+			// otherwise push a new interval
+			if (val == 0 && !data.empty() && data.back().val == 0)
+			{
+				data.back().x1 = x1;
+			}
+			else
+			{
+				Interval iv = { x0, x1, val };
+				data.push_back(iv);
+			}
+		}
+
+		void ConstructTree(size_t x0, size_t pivot, size_t x1, size_t idx_tree)
+		{
+			ENSURE(x0 < data.size());
+			ENSURE(x1 <= data.size());
+			ENSURE(x0 <= pivot);
+			ENSURE(pivot < x1);
+			ENSURE(idx_tree < tree.size());
+
+			tree[idx_tree].x0 = data[pivot].x0 << 1;
+			tree[idx_tree].x1 = data[pivot].x1;
+			if (data[pivot].val)
+				tree[idx_tree].x0 |= 1;
+
+			if (x0 < pivot)
+				ConstructTree(x0, (x0 + pivot) / 2, pivot, (idx_tree << 1) + 1);
+			if (pivot+1 < x1)
+				ConstructTree(pivot+1, (pivot + x1) / 2, x1, (idx_tree << 1) + 2);
+		}
+
+		void Finish()
+		{
+			size_t depth = ceil_log2(data.size() + 1);
+			tree.resize((1 << depth) - 1);
+
+			ConstructTree(0, data.size() / 2, data.size(), 0);
+		}
+
+		u16 Get(u16 x)
+		{
+			u32 i = 0;
+			while (true)
+			{
+ 				ASSERT(i < tree.size());
+				Interval2 interval = tree[i];
+				u16 x0 = interval.x0 >> 1;
+				u16 x1 = interval.x1;
+				if (x < x0)
+					i = (i << 1) + 1;
+				else if (x >= x1)
+					i = (i << 1) + 2;
+				else
+					return interval.x0 & 1 ? x1 : 0;
+			}
+		}
+	};
+
+	typedef RowTree Row;
+
+public:
+	u16 m_Width;
+	u16 m_Height;
+	std::vector<Row> m_JumpPointsRight;
+	std::vector<Row> m_JumpPointsLeft;
+	std::vector<Row> m_JumpPointsUp;
+	std::vector<Row> m_JumpPointsDown;
+
+	void reset(const Grid<TerrainTile>* terrain, ICmpPathfinder::pass_class_t passClass, u16 iGoal, u16 jGoal)
+	{
+		u16 w = terrain->m_W;
+		u16 h = terrain->m_H;
+		m_Width = w;
+		m_Height = h;
+
+		m_JumpPointsRight.reserve(h);
+		for (u16 j = 0; j < h; ++j)
+			m_JumpPointsRight.push_back(Row(w));
+
+		m_JumpPointsLeft.reserve(h);
+		for (u16 j = 0; j < h; ++j)
+			m_JumpPointsLeft.push_back(Row(w));
+
+		m_JumpPointsUp.reserve(w);
+		for (u16 i = 0; i < w; ++i)
+			m_JumpPointsUp.push_back(Row(h));
+
+		m_JumpPointsDown.reserve(w);
+		for (u16 i = 0; i < w; ++i)
+			m_JumpPointsDown.push_back(Row(h));
+
+		for (u16 j = 1; j < h - 1; ++j)
+		{
+			for (u16 i = 0; i < w-1; )
+			{
+				u16 i0 = i;
+				i++;
+				while (true)
+				{
+					if (i == w-1)
+					{
+						m_JumpPointsRight[j].SetRange(i0, i, 0);
+						break;
+					}
+
+					if (!IS_PASSABLE(terrain->get(i, j), passClass))
+					{
+						m_JumpPointsRight[j].SetRange(i0, i, 0);
+						break;
+					}
+
+					if ((i == iGoal && j == jGoal) ||
+						(!IS_PASSABLE(terrain->get(i, j-1), passClass)
+						&& IS_PASSABLE(terrain->get(i+1, j-1), passClass)) ||
+						(!IS_PASSABLE(terrain->get(i, j+1), passClass)
+						&& IS_PASSABLE(terrain->get(i+1, j+1), passClass)))
+					{
+						m_JumpPointsRight[j].SetRange(i0, i, i);
+						break;
+					}
+
+					i++;
+				}
+			}
+
+			m_JumpPointsRight[j].Finish();
+		}
+
+		for (u16 j = 1; j < h - 1; ++j)
+		{
+			for (u16 i = 0; i < w-1; )
+			{
+				u16 i0 = i;
+				i++;
+				while (true)
+				{
+					if (i == w-1)
+					{
+						m_JumpPointsLeft[j].SetRange(i0, i, 0);
+						break;
+					}
+
+					if (!IS_PASSABLE(terrain->get(w-1-i, j), passClass))
+					{
+						m_JumpPointsLeft[j].SetRange(i0, i, 0);
+						break;
+					}
+
+					if ((w-1-i == iGoal && j == jGoal) ||
+						(!IS_PASSABLE(terrain->get(w-1-i, j-1), passClass)
+						&& IS_PASSABLE(terrain->get(w-1-(i+1), j-1), passClass)) ||
+						(!IS_PASSABLE(terrain->get(w-1-i, j+1), passClass)
+						&& IS_PASSABLE(terrain->get(w-1-(i+1), j+1), passClass)))
+					{
+						m_JumpPointsLeft[j].SetRange(i0, i, i);
+						break;
+					}
+
+					i++;
+				}
+			}
+
+			m_JumpPointsLeft[j].Finish();
+		}
+
+		for (u16 i = 1; i < w - 1; ++i)
+		{
+			for (u16 j = 0; j < h-1; )
+			{
+				u16 j0 = j;
+				j++;
+				while (true)
+				{
+					if (j == h-1)
+					{
+						m_JumpPointsUp[i].SetRange(j0, j, 0);
+						break;
+					}
+
+					if (!IS_PASSABLE(terrain->get(i, j), passClass))
+					{
+						m_JumpPointsUp[i].SetRange(j0, j, 0);
+						break;
+					}
+
+					if ((i == iGoal && j == jGoal) ||
+						(!IS_PASSABLE(terrain->get(i-1, j), passClass)
+						&& IS_PASSABLE(terrain->get(i-1, j+1), passClass)) ||
+						(!IS_PASSABLE(terrain->get(i+1, j), passClass)
+						&& IS_PASSABLE(terrain->get(i+1, j+1), passClass)))
+					{
+						m_JumpPointsUp[i].SetRange(j0, j, j);
+						break;
+					}
+
+					j++;
+				}
+			}
+
+			m_JumpPointsUp[i].Finish();
+		}
+
+		for (u16 i = 1; i < w - 1; ++i)
+		{
+			for (u16 j = 0; j < h-1; )
+			{
+				u16 j0 = j;
+				j++;
+				while (true)
+				{
+					if (j == h-1)
+					{
+						m_JumpPointsDown[i].SetRange(j0, j, 0);
+						break;
+					}
+
+					if (!IS_PASSABLE(terrain->get(i, h-1-j), passClass))
+					{
+						m_JumpPointsDown[i].SetRange(j0, j, 0);
+						break;
+					}
+
+					if ((i == iGoal && h-1-j == jGoal) ||
+						(!IS_PASSABLE(terrain->get(i-1, h-1-j), passClass)
+						&& IS_PASSABLE(terrain->get(i-1, h-1-(j+1)), passClass)) ||
+						(!IS_PASSABLE(terrain->get(i+1, h-1-j), passClass)
+						&& IS_PASSABLE(terrain->get(i+1, h-1-(j+1)), passClass)))
+					{
+						m_JumpPointsDown[i].SetRange(j0, j, j);
+						break;
+					}
+
+					j++;
+				}
+			}
+
+			m_JumpPointsDown[i].Finish();
+		}
+
+// 		size_t bytes = 0;
+// 		for (u16 i = 1; i < w - 1; ++i)
+// 		{
+// 			bytes += m_JumpPointsUp[i].tree.size();
+// 			bytes += m_JumpPointsDown[i].tree.size();
+// 		}
+// 		for (u16 j = 1; j < h - 1; ++j)
+// 		{
+// 			bytes += m_JumpPointsRight[j].tree.size();
+// 			bytes += m_JumpPointsLeft[j].tree.size();
+// 		}
+// 		debug_printf(L"@@@ bytes = %d\n", bytes*4);
+
+	}
+
+	u16 GetJumpPointRight(u16 i, u16 j, u16 iGoal, u16 jGoal)
+	{
+		u16 jump = m_JumpPointsRight[j].Get(i);
+		return jump;
+	}
+
+	u16 GetJumpPointLeft(u16 i, u16 j, u16 iGoal, u16 jGoal)
+	{
+		u16 mirrorjump = m_JumpPointsLeft[j].Get(m_Width-1 - i);
+		u16 jump = m_Width-1 - mirrorjump;
+		return jump;
+	}
+
+	u16 GetJumpPointUp(u16 i, u16 j, u16 iGoal, u16 jGoal)
+	{
+		u16 jump = m_JumpPointsUp[i].Get(j);
+		return jump;
+	}
+
+	u16 GetJumpPointDown(u16 i, u16 j, u16 iGoal, u16 jGoal)
+	{
+		u16 mirrorjump = m_JumpPointsDown[i].Get(m_Height-1 - j);
+		u16 jump = m_Height-1 - mirrorjump;
+		return jump;
+	}
+};
+
+} // anon namespace
+
+/**
+ * Tile data for A* computation.
+ * (We store an array of one of these per terrain tile, so it ought to be optimised for size)
+ */
+struct PathfindTileJPS
+{
+public:
+	enum {
+		STATUS_UNEXPLORED = 0,
+		STATUS_OPEN = 1,
+		STATUS_CLOSED = 2
+	};
+
+	bool IsUnexplored() { return cost.GetStatus() == STATUS_UNEXPLORED; }
+	bool IsOpen() { return cost.GetStatus() == STATUS_OPEN; }
+	bool IsClosed() { return cost.GetStatus() == STATUS_CLOSED; }
+	void SetStatusOpen() { cost.SetStatus(STATUS_OPEN); }
+	void SetStatusClosed() { cost.SetStatus(STATUS_CLOSED); }
+
+	// Get pi,pj coords of predecessor to this tile on best path, given i,j coords of this tile
+	u16 GetPredI(u16 i) { return (u16)(i + cost.GetPredDI()); }
+	u16 GetPredJ(u16 j) { return (u16)(j + cost.GetPredDJ()); }
+	int GetPredDI() { return cost.GetPredDI(); }
+	int GetPredDJ() { return cost.GetPredDJ(); }
+	// Set the pi,pj coords of predecessor, given i,j coords of this tile
+	void SetPred(u16 pi_, u16 pj_, u16 i, u16 j)
+	{
+		cost.SetPred((int)pi_ - (int)i, (int)pj_ - (int)j);
+	}
+
+public:
+	CostAndExtra cost; // g (cost to this tile)
+};
+
+//////////////////////////////////////////////////////////
+
+struct PathfinderStateJPS
+{
+	u32 steps; // number of algorithm iterations
+
+	u16 iGoal, jGoal; // goal tile
+	u16 rGoal; // radius of goal (around tile center)
+
+	ICmpPathfinder::pass_class_t passClass;
+	std::vector<u32> moveCosts;
+
+	PriorityQueue open;
+	// (there's no explicit closed list; it's encoded in PathfindTile)
+
+	PathfindTileJPSGrid* tiles;
+	Grid<TerrainTile>* terrain;
+
+	bool ignoreImpassable; // allows us to escape if stuck in patches of impassability
+
+	Cost hBest; // heuristic of closest discovered tile to goal
+	u16 iBest, jBest; // closest tile
+
+	JumpPointCache* jpc;
+	BitGrid passGrid;
+	BitGrid jumpPointGrid0;
+	BitGrid jumpPointGrid1;
+	BitGrid jumpPointGrid2;
+	BitGrid jumpPointGrid3;
+
+#if PATHFIND_STATS
+	// Performance debug counters
+	size_t numProcessed;
+	size_t numImproveOpen;
+	size_t numAddToOpen;
+	size_t sumOpenSize;
+#endif
+};
+
+static bool AtGoal(u16 i, u16 j, const ICmpPathfinder::Goal& goal)
+{
+	// Allow tiles slightly more than sqrt(2) from the actual goal,
+	// i.e. adjacent diagonally to the target tile
+	fixed tolerance = entity_pos_t::FromInt(TERRAIN_TILE_SIZE*3/2);
+
+	if (goal.type == ICmpPathfinder::Goal::POINT)
+	{
+		u16 gi, gj;
+		gi = (u16)(goal.x*ICmpObstructionManager::NAVCELLS_PER_TILE / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+		gj = (u16)(goal.z*ICmpObstructionManager::NAVCELLS_PER_TILE / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+		return gi == i && gj == j;
+	}
+
+	entity_pos_t x, z;
+	CCmpPathfinder::TileCenter(i, j, x, z);
+	fixed dist = CCmpPathfinder::DistanceToGoal(CFixedVector2D(x, z), goal);
+	return (dist < tolerance);
+}
+
+// Calculate heuristic cost from tile i,j to destination
+// (This ought to be an underestimate for correctness)
+static Cost CalculateHeuristic(u16 i, u16 j, u16 iGoal, u16 jGoal, u16 rGoal)
+{
+	int di = abs((int)i - (int)iGoal);
+	int dj = abs((int)j - (int)jGoal);
+	int diag = std::min(di, dj);
+	return Cost(di-diag + dj-diag, diag);
+}
+
+
+// Do the A* processing for a neighbour tile i,j.
+static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, Cost pg, PathfinderStateJPS& state)
+{
+#if PATHFIND_STATS
+	state.numProcessed++;
+#endif
+
+	// Reject impassable tiles
+	if (!IS_PASSABLE(state.terrain->get(i, j), state.passClass) && !state.ignoreImpassable)
+		return;
+
+	PathfindTileJPS& n = state.tiles->get(i, j);
+
+ 	if (n.IsClosed())
+ 		return;
+
+	Cost dg;
+	if (pi == i)
+		dg = Cost::horizvert(abs((int)pj - (int)j));
+	else if (pj == j)
+		dg = Cost::horizvert(abs((int)pi - (int)i));
+	else
+	{
+		ASSERT(abs((int)pi - (int)i) == abs((int)pj - (int)j));
+		dg = Cost::diag(abs((int)pi - (int)i));
+	}
+
+	Cost g = pg + dg; // cost to this tile = cost to predecessor + delta from predecessor
+
+	Cost h = CalculateHeuristic(i, j, state.iGoal, state.jGoal, state.rGoal);
+
+	// If this is a new tile, compute the heuristic distance
+	if (n.IsUnexplored())
+	{
+		// Remember the best tile we've seen so far, in case we never actually reach the target
+		if (h < state.hBest)
+		{
+			state.hBest = h;
+			state.iBest = i;
+			state.jBest = j;
+		}
+	}
+	else
+	{
+		// If we've already seen this tile, and the new path to this tile does not have a
+		// better cost, then stop now
+		if (g >= n.cost)
+			return;
+
+		// Otherwise, we have a better path.
+
+		// If we've already added this tile to the open list:
+		if (n.IsOpen())
+		{
+			// This is a better path, so replace the old one with the new cost/parent
+			Cost gprev = n.cost.GetCost();
+			n.cost.SetCost(g);
+			n.SetPred(pi, pj, i, j);
+			state.open.promote(TileID(i, j), gprev + h, g + h);
+#if PATHFIND_STATS
+			state.numImproveOpen++;
+#endif
+			return;
+		}
+	}
+
+	// Add it to the open list:
+	n.SetStatusOpen();
+	n.cost.SetCost(g);
+	n.SetPred(pi, pj, i, j);
+	PriorityQueue::Item t = { TileID(i, j), g + h };
+	state.open.push(t);
+#if PATHFIND_STATS
+	state.numAddToOpen++;
+#endif
+}
+
+#define PASSABLE(i, j) IS_PASSABLE(state.terrain->get(i, j), state.passClass)
+
+#if USE_JUMPPOINT_CACHE
+
+static void AddJumpedHoriz(u16 i, u16 j, i8 di, Cost g, PathfinderStateJPS& state)
+{
+	if (di > 0)
+	{
+		u16 jump = state.jpc->GetJumpPointRight(i, j, state.iGoal, state.jGoal);
+		if (jump != 0)
+			ProcessNeighbour(i, j, jump, j, g, state);
+	}
+	else
+	{
+		u16 jump = state.jpc->GetJumpPointLeft(i, j, state.iGoal, state.jGoal);
+		if (jump != state.terrain->m_W-1)
+			ProcessNeighbour(i, j, jump, j, g, state);
+	}
+}
+
+static bool HasJumpedHoriz(u16 i, u16 j, i8 di, PathfinderStateJPS& state)
+{
+	if (di > 0)
+	{
+		u16 jump = state.jpc->GetJumpPointRight(i, j, state.iGoal, state.jGoal);
+		return (jump != 0);
+	}
+	else
+	{
+		u16 jump = state.jpc->GetJumpPointLeft(i, j, state.iGoal, state.jGoal);
+		return (jump != state.terrain->m_W-1);
+	}
+}
+
+static void AddJumpedVert(u16 i, u16 j, i8 dj, Cost g, PathfinderStateJPS& state)
+{
+	if (dj > 0)
+	{
+		u16 jump = state.jpc->GetJumpPointUp(i, j, state.iGoal, state.jGoal);
+		if (jump != 0)
+			ProcessNeighbour(i, j, i, jump, g, state);
+	}
+	else
+	{
+		u16 jump = state.jpc->GetJumpPointDown(i, j, state.iGoal, state.jGoal);
+		if (jump != state.terrain->m_H-1)
+			ProcessNeighbour(i, j, i, jump, g, state);
+		return;
+	}
+}
+
+static bool HasJumpedVert(u16 i, u16 j, i8 dj, PathfinderStateJPS& state)
+{
+	if (dj > 0)
+	{
+		u16 jump = state.jpc->GetJumpPointUp(i, j, state.iGoal, state.jGoal);
+		return (jump != 0);
+	}
+	else
+	{
+		u16 jump = state.jpc->GetJumpPointDown(i, j, state.iGoal, state.jGoal);
+		return (jump != state.terrain->m_H-1);
+	}
+}
+
+#else // USE_JUMPPOINT_CACHE
+
+static void AddJumpedHoriz(u16 i, u16 j, i8 di, Cost g, PathfinderStateJPS& state)
+{
+	ASSERT(di == 1 || di == -1);
+	u16 ni = i + di;
+	while (true)
+	{
+		if (!PASSABLE(ni, j))
+			break;
+
+		if ((ni == state.iGoal && j == state.jGoal) ||
+			(!PASSABLE(ni, j-1)
+			&& PASSABLE(ni+di, j-1)) ||
+			(!PASSABLE(ni, j+1)
+			&& PASSABLE(ni+di, j+1)))
+		{
+			ProcessNeighbour(i, j, ni, j, g, state);
+			break;
+		}
+
+		ni += di;
+	}
+}
+
+static bool HasJumpedHoriz(u16 i, u16 j, i8 di, PathfinderStateJPS& state)
+{
+	ASSERT(di == 1 || di == -1);
+	u16 ni = i + di;
+	while (true)
+	{
+		if (!PASSABLE(ni, j))
+			return false;
+
+		if ((ni == state.iGoal && j == state.jGoal) ||
+			(!PASSABLE(ni, j-1)
+			&& PASSABLE(ni+di, j-1)) ||
+			(!PASSABLE(ni, j+1)
+			&& PASSABLE(ni+di, j+1)))
+		{
+			return true;
+		}
+
+		ni += di;
+	}
+}
+
+static void AddJumpedVert(u16 i, u16 j, i8 dj, Cost g, PathfinderStateJPS& state)
+{
+	ASSERT(dj == 1 || dj == -1);
+	u16 nj = j + dj;
+	while (true)
+	{
+		if (!PASSABLE(i, nj))
+			break;
+
+		if ((i == state.iGoal && nj == state.jGoal) ||
+			(!PASSABLE(i-1, nj)
+			 && PASSABLE(i-1, nj+dj)) ||
+			(!PASSABLE(i+1, nj)
+			 && PASSABLE(i+1, nj+dj)))
+		{
+			ProcessNeighbour(i, j, i, nj, g, state);
+			break;
+		}
+
+		nj += dj;
+	}
+}
+
+static bool HasJumpedVert(u16 i, u16 j, i8 dj, PathfinderStateJPS& state)
+{
+	ASSERT(dj == 1 || dj == -1);
+	u16 nj = j + dj;
+	while (true)
+	{
+		if (!PASSABLE(i, nj))
+			return false;
+
+		if ((i == state.iGoal && nj == state.jGoal) ||
+			(!PASSABLE(i-1, nj)
+			&& PASSABLE(i-1, nj+dj)) ||
+			(!PASSABLE(i+1, nj)
+			&& PASSABLE(i+1, nj+dj)))
+		{
+			return true;
+		}
+
+		nj += dj;
+	}
+}
+
+#endif // USE_JUMPPOINT_CACHE
+
+
+
+static void AddJumpedDiag(u16 i, u16 j, i8 di, i8 dj, Cost g, PathfinderStateJPS& state)
+{
+// 	ProcessNeighbour(i, j, (u16)(i + di), (u16)(j + dj), g, state);
+// 	return;
+
+	ASSERT(di == 1 || di == -1);
+	ASSERT(dj == 1 || dj == -1);
+
+	u16 ni = i + di;
+	u16 nj = j + dj;
+	while (true)
+	{
+		if (!PASSABLE(ni, nj))
+			return;
+
+		if ((ni == state.iGoal && nj == state.jGoal) ||
+			(!PASSABLE(ni - di, nj)
+			 && PASSABLE(ni - di, nj + dj)) ||
+			(!PASSABLE(ni, nj - dj)
+			 && PASSABLE(ni + di, nj - dj)))
+		{
+			ProcessNeighbour(i, j, ni, nj, g, state);
+			return;
+		}
+
+		if (HasJumpedHoriz(ni, nj, di, state) || HasJumpedVert(ni, nj, dj, state))
+		{
+			ProcessNeighbour(i, j, ni, nj, g, state);
+			return;
+		}
+
+		ni += di;
+		nj += dj;
+	}
+}
+
+
+void CCmpPathfinder::ComputePathJPS(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& path)
+{
+	UpdateGrid();
+
+	PathfinderStateJPS state = { 0 };
+
+	static JumpPointCache* jpc;
+#if USE_JUMPPOINT_CACHE
+ 	if (!jpc)
+ 	{
+ 		jpc = new JumpPointCache;
+		NearestNavcell(goal.x, goal.z, state.iGoal, state.jGoal);
+ 		jpc->reset(m_Grid, passClass, state.iGoal, state.jGoal);
+ 	}
+#endif
+	state.jpc = jpc;
+
+	PROFILE3("ComputePathJPS");
+	double time = timer_Time();
+
+	// Convert the start/end coordinates to tile indexes
+	u16 i0, j0;
+	NearestNavcell(x0, z0, i0, j0);
+	NearestNavcell(goal.x, goal.z, state.iGoal, state.jGoal);
+
+	// If we're already at the goal tile, then move directly to the exact goal coordinates
+	if (AtGoal(i0, j0, goal))
+	{
+		Waypoint w = { goal.x, goal.z };
+		path.m_Waypoints.push_back(w);
+		return;
+	}
+
+	// If the target is a circle, we want to aim for the edge of it (so e.g. if we're inside
+	// a large circle then the heuristics will aim us directly outwards);
+	// otherwise just aim at the center point. (We'll never try moving outwards to a square shape.)
+	if (goal.type == Goal::CIRCLE)
+		state.rGoal = (u16)(goal.hw / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+	else
+		state.rGoal = 0;
+
+	state.passClass = passClass;
+	state.moveCosts = m_MoveCosts.at(costClass);
+
+	state.steps = 0;
+
+	state.tiles = new PathfindTileJPSGrid(m_Grid->m_W, m_Grid->m_H);
+	state.terrain = m_Grid;
+
+	state.iBest = i0;
+	state.jBest = j0;
+	state.hBest = CalculateHeuristic(i0, j0, state.iGoal, state.jGoal, state.rGoal);
+
+	PriorityQueue::Item start = { TileID(i0, j0), Cost() };
+	state.open.push(start);
+	state.tiles->get(i0, j0).SetStatusOpen();
+	state.tiles->get(i0, j0).SetPred(i0, j0, i0, j0);
+	state.tiles->get(i0, j0).cost.SetCost(Cost());
+
+	// To prevent units getting very stuck, if they start on an impassable tile
+	// surrounded entirely by impassable tiles, we ignore the impassability
+	state.ignoreImpassable = !IS_PASSABLE(state.terrain->get(i0, j0), state.passClass);
+
+	while (1)
+	{
+		++state.steps;
+
+		// Hack to avoid spending ages computing giant paths, particularly when
+		// the destination is unreachable
+// 		if (state.steps > 40000)
+// 			break;
+
+		// If we ran out of tiles to examine, give up
+		if (state.open.empty())
+			break;
+
+#if PATHFIND_STATS
+		state.sumOpenSize += state.open.size();
+#endif
+
+		// Move best tile from open to closed
+		PriorityQueue::Item curr = state.open.pop();
+		u16 i = curr.id.i();
+		u16 j = curr.id.j();
+		state.tiles->get(i, j).SetStatusClosed();
+
+		// If we've reached the destination, stop
+		if (AtGoal(i, j, goal))
+		{
+			state.iBest = i;
+			state.jBest = j;
+			state.hBest = Cost();
+			break;
+		}
+
+		// As soon as we find an escape route from the impassable terrain,
+		// take it and forbid any further use of impassable tiles
+		if (state.ignoreImpassable)
+		{
+			if (i > 0 && IS_PASSABLE(state.terrain->get(i-1, j), state.passClass))
+				state.ignoreImpassable = false;
+			else if (i < m_MapSize-1 && IS_PASSABLE(state.terrain->get(i+1, j), state.passClass))
+				state.ignoreImpassable = false;
+			else if (j > 0 && IS_PASSABLE(state.terrain->get(i, j-1), state.passClass))
+				state.ignoreImpassable = false;
+			else if (j < m_MapSize-1 && IS_PASSABLE(state.terrain->get(i, j+1), state.passClass))
+				state.ignoreImpassable = false;
+		}
+
+		PathfindTileJPS tile = state.tiles->get(i, j);
+		Cost g = tile.cost.GetCost();
+		int dpi = tile.GetPredDI();
+		int dpj = tile.GetPredDJ();
+		dpi = (dpi < 0 ? -1 : dpi > 0 ? 1 : 0);
+		dpj = (dpj < 0 ? -1 : dpj > 0 ? 1 : 0);
+
+		if (dpi != 0 && dpj == 0)
+		{
+			if (!IS_PASSABLE(state.terrain->get(i, j-1), state.passClass))
+				AddJumpedDiag(i, j, -dpi, -1, g, state);
+			if (!IS_PASSABLE(state.terrain->get(i, j+1), state.passClass))
+				AddJumpedDiag(i, j, -dpi, +1, g, state);
+
+			AddJumpedHoriz(i, j, -dpi, g, state);
+		}
+		else if (dpi == 0 && dpj != 0)
+		{
+			if (!IS_PASSABLE(state.terrain->get(i-1, j), state.passClass))
+				AddJumpedDiag(i, j, -1, -dpj, g, state);
+			if (!IS_PASSABLE(state.terrain->get(i+1, j), state.passClass))
+				AddJumpedDiag(i, j, +1, -dpj, g, state);
+
+			AddJumpedVert(i, j, -dpj, g, state);
+		}
+		else if (dpi != 0 && dpj != 0)
+		{
+			if (!IS_PASSABLE(state.terrain->get(i + dpi, j), state.passClass))
+				AddJumpedDiag(i, j, dpi, -dpj, g, state);
+			if (!IS_PASSABLE(state.terrain->get(i, j + dpj), state.passClass))
+				AddJumpedDiag(i, j, -dpi, dpj, g, state);
+
+			AddJumpedHoriz(i, j, -dpi, g, state);
+			AddJumpedVert(i, j, -dpj, g, state);
+			AddJumpedDiag(i, j, -dpi, -dpj, g, state);
+		}
+		else
+		{
+			ProcessNeighbour(i, j, (u16)(i-1), (u16)(j-1), g, state);
+			ProcessNeighbour(i, j, (u16)(i+1), (u16)(j-1), g, state);
+			ProcessNeighbour(i, j, (u16)(i-1), (u16)(j+1), g, state);
+			ProcessNeighbour(i, j, (u16)(i+1), (u16)(j+1), g, state);
+			ProcessNeighbour(i, j, (u16)(i-1), j, g, state);
+			ProcessNeighbour(i, j, (u16)(i+1), j, g, state);
+			ProcessNeighbour(i, j, i, (u16)(j-1), g, state);
+			ProcessNeighbour(i, j, i, (u16)(j+1), g, state);
+		}
+	}
+
+	// Reconstruct the path (in reverse)
+	u16 ip = state.iBest, jp = state.jBest;
+	while (ip != i0 || jp != j0)
+	{
+		PathfindTileJPS& n = state.tiles->get(ip, jp);
+		entity_pos_t x, z;
+		NavcellCenter(ip, jp, x, z);
+		Waypoint w = { x, z };
+		path.m_Waypoints.push_back(w);
+
+		// Follow the predecessor link
+		ip = n.GetPredI(ip);
+		jp = n.GetPredJ(jp);
+	}
+
+	// Save this grid for debug display
+	m_DebugTime = timer_Time() - time;
+	delete m_DebugGridJPS;
+	m_DebugGridJPS = state.tiles;
+	m_DebugSteps = state.steps;
+
+	PROFILE2_ATTR("from: (%d, %d)", i0, j0);
+	PROFILE2_ATTR("to: (%d, %d)", state.iGoal, state.jGoal);
+	PROFILE2_ATTR("reached: (%d, %d)", state.iBest, state.jBest);
+	PROFILE2_ATTR("steps: %d", state.steps);
+
+#if PATHFIND_STATS
+	debug_printf(L"PATHFINDER: steps=%d avgo=%d proc=%d impo=%d addo=%d\n", state.steps, state.sumOpenSize/state.steps, state.numProcessed, state.numImproveOpen, state.numAddToOpen);
+#endif
+}
+
+void CCmpPathfinder::GetDebugDataJPS(u32& steps, double& time, Grid<u8>& grid)
+{
+	steps = m_DebugSteps;
+	time = m_DebugTime;
+
+	grid = Grid<u8>(m_DebugGridJPS->m_W, m_DebugGridJPS->m_H);
+	for (u16 j = 0; j < grid.m_H; ++j)
+	{
+		for (u16 i = 0; i < grid.m_W; ++i)
+		{
+			PathfindTileJPS t = m_DebugGridJPS->get(i, j);
+			grid.set(i, j, (t.IsOpen() ? 1 : 0) | (t.IsClosed() ? 2 : 0));
+		}
+	}
+}
\ No newline at end of file
